package es.bcn.gca.necn.business.model.bo.impl;

import java.util.List;

import net.opentrends.openframe.services.logging.LoggingService;
import net.opentrends.openframe.services.persistence.hibernate.HibernateDAO;
import es.bcn.gca.necn.common.model.PaquetsVO;
import es.bcn.gca.necn.common.model.PeticionsVO;


public class PaquetsBOImpl  implements es.bcn.gca.necn.common.model.bo.PaquetsBO {
	HibernateDAO hibernateDao;

	/** Accs al servei de traces. */
	LoggingService logService;

	public HibernateDAO getHibernateDao() {
		return hibernateDao;
	}

	public void setHibernateDao(HibernateDAO hibernateDao) {
		this.hibernateDao = hibernateDao;
	}

	/** Default constructor. */	
	/**
	 * 
	 */
	public PaquetsBOImpl() {
		super();
	}

	public void delete(PaquetsVO paquets) throws Exception {
		
		hibernateDao.delete(paquets);
	}

	public List findAll() {
		return hibernateDao.findAll(PaquetsVO.class);
	}

	public PaquetsVO get(PaquetsVO paquets) {
		paquets = (PaquetsVO) hibernateDao.get(PaquetsVO.class,
				paquets.getPaqId());
		return paquets;
	}

	public PaquetsVO load(PaquetsVO paquets) {
		paquets = (PaquetsVO) hibernateDao.load(PaquetsVO.class,
				paquets.getPaqId());
		return paquets;
	}

	public void save(PaquetsVO paquets) throws Exception {
		
		hibernateDao.save(paquets);
	}

	public void saveOrUpdate(PaquetsVO paquets) throws Exception {
		
		hibernateDao.saveOrUpdate(paquets);
	}

	public void update(PaquetsVO paquets) throws Exception {
		
		hibernateDao.update(paquets);
	}

	public void addToPeticio(String paquet, String peticio) throws Exception {
		
		PeticionsVO peticions = (PeticionsVO) hibernateDao.load(PeticionsVO.class, peticio);
		PaquetsVO paquets = (PaquetsVO) hibernateDao.load(PaquetsVO.class, paquet);

		paquets.addToPeticio(peticions);
		hibernateDao.flush();
	}

	public LoggingService getLogService() {
		return logService;
	}

	public void setLogService(LoggingService logService) {
		this.logService = logService;
	}
  
}
