package es.bcn.gca.necn.common.model.bo;

import java.util.List;

import es.bcn.gca.necn.common.model.EstatsVO;

public interface EstatsBO {
	
	/**
	 * Desa un nou registe de PeticionsVO a la BD
	 * @param log a desar
	 * @throws Exception
	 */
	public void save(EstatsVO peticio) throws Exception;
	
    /**
     * Desa un nou registre de EstatsVO, o l'actualitza si ja existeix
     * @param log a desar
     * @throws Exception
     */
    public void saveOrUpdate(EstatsVO peticio) throws Exception;
    
    /**
     * Actualitza un registre log existent
     * @param log a actualitzar
     * @throws Exception
     */
    public void update(EstatsVO peticio) throws Exception;
    
	/**
	 * Esborra un registre de tipus EstatsVO
	 * @param log a esborrar
	 * @throws Exception
	 */
	public void delete(EstatsVO peticio) throws Exception ;
	
	/**
	 * Actualitza les dades de l'objecte EstatsVO amb les obtingudes de la BD
	 * @param log a refrescar
	 * @return objecte EstatsVO amb les dades actualitzades de la BD
	 */
	public EstatsVO load(EstatsVO peticio);
	public EstatsVO get(EstatsVO peticio);
	
    /**
     * Mtode que retorna una List amb tots els objectes de tipus EstatsVO de la BD
     * @return List amb tots els objectes de tipus EstatsVO
     */
    public List findAll();
    
	
}
