package es.bcn.gca.necn.common.model.bo;

import java.util.List;

import es.bcn.gca.necn.common.model.GrupsVO;

public interface GrupsBO {
	
	/**
	 * Desa un nou registe de PeticionsVO a la BD
	 * @param log a desar
	 * @throws Exception
	 */
	public void save(GrupsVO peticio) throws Exception;
	
    /**
     * Desa un nou registre de GrupsVO, o l'actualitza si ja existeix
     * @param log a desar
     * @throws Exception
     */
    public void saveOrUpdate(GrupsVO peticio) throws Exception;
    
    /**
     * Actualitza un registre log existent
     * @param log a actualitzar
     * @throws Exception
     */
    public void update(GrupsVO peticio) throws Exception;
    
	/**
	 * Esborra un registre de tipus GrupsVO
	 * @param log a esborrar
	 * @throws Exception
	 */
	public void delete(GrupsVO peticio) throws Exception ;
	
	/**
	 * Actualitza les dades de l'objecte GrupsVO amb les obtingudes de la BD
	 * @param log a refrescar
	 * @return objecte GrupsVO amb les dades actualitzades de la BD
	 */
	public GrupsVO load(GrupsVO peticio);
	public GrupsVO get(GrupsVO peticio);
	
    /**
     * Mtode que retorna una List amb tots els objectes de tipus GrupsVO de la BD
     * @return List amb tots els objectes de tipus GrupsVO
     */
    public List findAll();
    
	
}
