package es.bcn.gca.necn.common.model.bo;

import java.util.List;

import es.bcn.gca.necn.common.model.PaquetsVO;
import es.bcn.gca.necn.common.model.PeticionsVO;

public interface PaquetsBO {
	
	/**
	 * Desa un nou registe de PeticionsVO a la BD
	 * @param log a desar
	 * @throws Exception
	 */
	public void save(PaquetsVO peticio) throws Exception;
	
    /**
     * Desa un nou registre de PaquetsVO, o l'actualitza si ja existeix
     * @param log a desar
     * @throws Exception
     */
    public void saveOrUpdate(PaquetsVO peticio) throws Exception;
    
    /**
     * Actualitza un registre log existent
     * @param log a actualitzar
     * @throws Exception
     */
    public void update(PaquetsVO peticio) throws Exception;
    
	/**
	 * Esborra un registre de tipus PaquetsVO
	 * @param log a esborrar
	 * @throws Exception
	 */
	public void delete(PaquetsVO peticio) throws Exception ;
	
	/**
	 * Actualitza les dades de l'objecte PaquetsVO amb les obtingudes de la BD
	 * @param log a refrescar
	 * @return objecte PaquetsVO amb les dades actualitzades de la BD
	 */
	public PaquetsVO load(PaquetsVO peticio);
	public PaquetsVO get(PaquetsVO peticio);
	
    /**
     * Mtode que retorna una List amb tots els objectes de tipus PaquetsVO de la BD
     * @return List amb tots els objectes de tipus PaquetsVO
     */
    public List findAll();
    
    public void addToPeticio(String paquet, String peticio) throws Exception;
}
