package es.bcn.gca.necn.common.model.bo;

import java.util.List;

import es.bcn.gca.necn.common.model.PaquetsVO;
import es.bcn.gca.necn.common.model.PeticionsVO;

public interface PeticionsBO {
	
	/**
	 * Desa un nou registe de PeticionsVO a la BD
	 * @param log a desar
	 * @throws Exception
	 */
	public void save(PeticionsVO peticio) throws Exception;
	
    /**
     * Desa un nou registre de PeticionsVO, o l'actualitza si ja existeix
     * @param log a desar
     * @throws Exception
     */
    public void saveOrUpdate(PeticionsVO peticio) throws Exception;
    
    /**
     * Actualitza un registre log existent
     * @param log a actualitzar
     * @throws Exception
     */
    public void update(PeticionsVO peticio) throws Exception;
    
	/**
	 * Esborra un registre de tipus PeticionsVO
	 * @param log a esborrar
	 * @throws Exception
	 */
	public void delete(PeticionsVO peticio) throws Exception ;
	
	/**
	 * Actualitza les dades de l'objecte PeticionsVO amb les obtingudes de la BD
	 * @param log a refrescar
	 * @return objecte PeticionsVO amb les dades actualitzades de la BD
	 */
	public PeticionsVO load(PeticionsVO peticio);
	public PeticionsVO get(PeticionsVO peticio);
	
    /**
     * Mtode que retorna una List amb tots els objectes de tipus PeticionsVO de la BD
     * @return List amb tots els objectes de tipus PeticionsVO
     */
    public List findAll();
    
	//public void addToPaquet(PeticionsVO peticio, PaquetsVO paquet) throws Exception;
}
