package es.bcn.gca.necn.common.model.bo;

import java.util.List;

import es.bcn.gca.necn.common.model.PaquetsVO;
import es.bcn.gca.necn.common.model.PeticionsVO;
import es.bcn.gca.necn.common.model.ProductesVO;

public interface ProductesBO {
	
	/**
	 * Desa un nou registe de PeticionsVO a la BD
	 * @param log a desar
	 * @throws Exception
	 */
	public void save(ProductesVO peticio) throws Exception;
	
    /**
     * Desa un nou registre de ProductesVO, o l'actualitza si ja existeix
     * @param log a desar
     * @throws Exception
     */
    public void saveOrUpdate(ProductesVO peticio) throws Exception;
    
    /**
     * Actualitza un registre log existent
     * @param log a actualitzar
     * @throws Exception
     */
    public void update(ProductesVO peticio) throws Exception;
    
	/**
	 * Esborra un registre de tipus ProductesVO
	 * @param log a esborrar
	 * @throws Exception
	 */
	public void delete(ProductesVO peticio) throws Exception ;
	
	/**
	 * Actualitza les dades de l'objecte ProductesVO amb les obtingudes de la BD
	 * @param log a refrescar
	 * @return objecte ProductesVO amb les dades actualitzades de la BD
	 */
	public ProductesVO load(ProductesVO peticio);
	public ProductesVO get(ProductesVO peticio);
	
    /**
     * Mtode que retorna una List amb tots els objectes de tipus ProductesVO de la BD
     * @return List amb tots els objectes de tipus ProductesVO
     */
    public List findAll();
    
}
