package es.bcn.gca.necn.web.struts.action;

import java.util.Date;

import net.opentrends.openframe.core.util.beanutils.BeanUtils;
import net.opentrends.openframe.services.configuration.springframework.beans.factory.config.SuffixBasedPropertyPlaceholderConfigurer;
import net.opentrends.openframe.services.exceptions.BusinessException;
import net.opentrends.openframe.services.i18n.I18nService;
import net.opentrends.openframe.services.persistence.exception.PersistenceServiceException;
import net.opentrends.openframe.services.web.lists.ValueListActionHelper;
import net.opentrends.openframe.services.web.struts.DispatchActionSupport;
import net.opentrends.openframe.services.web.struts.SpringBindingActionForm;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.springframework.dao.DataIntegrityViolationException;

import es.bcn.gca.necn.common.model.PaquetsVO;
import es.bcn.gca.necn.common.model.bo.ContextBO;
import es.bcn.gca.necn.common.model.bo.EstatsBO;
import es.bcn.gca.necn.common.model.bo.GrupsBO;
import es.bcn.gca.necn.common.model.bo.PaquetsBO;
import es.bcn.gca.necn.common.model.bo.PeticionsBO;
import es.bcn.gca.necn.web.pojo.PaquetsTO;
import fr.improve.struts.taglib.layout.util.FormUtils;

/**
 * Action example for XxxBO
 * 
 * @author MMO
 */

public class PaquetsAc extends DispatchActionSupport  {
	/**
	 * BO en el que deleguem les crides
	 */
    private PaquetsBO paquetsBO;
    private EstatsBO estatsBO;
    private PeticionsBO peticionsBO;
    private ContextBO contextsBO;
    private GrupsBO grupsBO;
    private ValueListActionHelper valueListActionHelper;
    private SuffixBasedPropertyPlaceholderConfigurer configurationService;
    private I18nService i18nService;
    private Date data_creacio;
    private Date data;
    
	/**
	 * Bsqueda inicial, idntico a search pero antes de iniciar la bsqueda borra todos los parmetros
	 * que encuentre en la session
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return
	 * @throws Exception
	 */
	public ActionForward searchIni(ActionMapping mapping, ActionForm form,
	        javax.servlet.http.HttpServletRequest request,
	        javax.servlet.http.HttpServletResponse response)
	        throws Exception {	    	    	      
		logService.getLog(this.getClass()).debug("searchIni");
	    request.getSession().setAttribute(valueListActionHelper.getTableId(), null);  	  
	    
	    return this.search(mapping,form,request,response);
	}
	
	/**
	 * Bsqueda, realiza una consulta
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return
	 * @throws Exception
	 * @see @see es.bcn.fwk.prototipus.web.struts.action.actionaccount2#search(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public ActionForward search(ActionMapping mapping, ActionForm form,
	        javax.servlet.http.HttpServletRequest request,
	        javax.servlet.http.HttpServletResponse response)
	        throws Exception {		
		logService.getLog(this.getClass()).debug("search");
		
		SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
		PaquetsTO to = (PaquetsTO) actionForm.getTarget();
		
		BeanUtils.copyProperties(form, to);				
		valueListActionHelper.search(mapping,form,request,response);	    	                
	    
		return mapping.findForward("success");
	}
    
    /**
	 * Muestra el formulario de mantenimiento en modo de creacin. 
	 * 
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return
	 * @throws Exception
	 */
    public ActionForward create(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("create");
		   	
	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
			data = new Date();
		   	data_creacio = new Date(data.getTime());
		   	
		   	PaquetsTO to = (PaquetsTO) actionForm.getTarget();
		   	to.setPaqEstat("ATURAT");
		   	to.setPaqDataCreacio(data_creacio);
		   	to.setPaqDataModif(data_creacio);
		   	to.setPaqVersio(0);
	    	FormUtils.setFormDisplayMode(request, form, FormUtils.CREATE_MODE);

	    	return mapping.findForward("success");
    }
    
    public ActionForward save(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
    		logService.getLog(this.getClass()).debug("save");
    		ActionMessages errors = new ActionMessages();
    		
    		SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
            PaquetsTO to = (PaquetsTO) actionForm.getTarget();
            PaquetsVO vo = new PaquetsVO();
           
            BeanUtils.copyProperties(vo, to);
            vo = paquetsBO.load(vo);
            BeanUtils.copyProperties(vo, to);
            
            if (vo.getPaqId() != null) {
            	try{
            		paquetsBO.saveOrUpdate(vo);
            	}catch (DataIntegrityViolationException e) {
					String error="error.variable";
					String mensage=e.getMostSpecificCause().getLocalizedMessage();
					errors.add("errorGeneral", new ActionMessage(error,mensage));
				}catch (PersistenceServiceException e) {
					String error="error.variable";
					String mensage=e.getLocalizedMessage();
					errors.add("errorGeneral", new ActionMessage(error,mensage));
				}catch (BusinessException e) {
					String error="error.variable";
					String mensage=e.getLocalizedMessage();
					errors.add("errorGeneral", new ActionMessage(error,mensage));
				}catch (Exception e) {
					String error="error.variable";
					String mensage=e.getLocalizedMessage();
					errors.add("errorGeneral", new ActionMessage(error,mensage));
				}
            	
            }

            return mapping.findForward("list");
        }

        public ActionForward saveNew(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
        	logService.getLog(this.getClass()).debug("saveNew");
    		ActionMessages errors = new ActionMessages();
    		
        	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;        
            PaquetsTO to = (PaquetsTO) actionForm.getTarget();
            PaquetsVO vo = new PaquetsVO();
                   
            BeanUtils.copyProperties(vo, to);
            try{
            	paquetsBO.save(vo);
            }
    		catch (DataIntegrityViolationException e) {
				String error="error.variable";
				String mensage=e.getMostSpecificCause().getLocalizedMessage();
				errors.add("errorGeneral", new ActionMessage(error,mensage));
			}catch (PersistenceServiceException e) {
				String error="error.variable";
				String mensage=e.getLocalizedMessage();
				errors.add("errorGeneral", new ActionMessage(error,mensage));
			}catch (BusinessException e) {
				String error="error.variable";
				String mensage=e.getLocalizedMessage();
				errors.add("errorGeneral", new ActionMessage(error,mensage));
			}catch (Exception e) {
				String error="error.variable";
				String mensage=e.getLocalizedMessage();
				errors.add("errorGeneral", new ActionMessage(error,mensage));
			};
            
			if (errors.isEmpty()){
				paquetsBO.addToPeticio(vo.getPaqId(),(String)request.getSession().getAttribute("petIdNou"));
			}
			
            return mapping.findForward("list");
        }

    /**
	 * Muestra el formulario con los campos en modo de edicin.
	 * 
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return
	 * @throws Exception
	 */
    public ActionForward edit(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("edit");

	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
	    	PaquetsTO to = (PaquetsTO) actionForm.getTarget();
			
	    	PaquetsVO vo = new PaquetsVO();	
	    	
	    	BeanUtils.copyProperties(vo, to);
	    	vo = paquetsBO.load(vo);
		    BeanUtils.copyProperties(to, vo);
            
		    FormUtils.setFormDisplayMode(request, form, FormUtils.EDIT_MODE);
		    
            return mapping.findForward("success");
    }
    
    /**
	 * Muestra los campos de un registro en modo consulta.
	 * 
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return
	 * @throws Exception
	 */
    public ActionForward inspect(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("inspect");
						
	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
	    	PaquetsTO to = (PaquetsTO) actionForm.getTarget();
			
	    	PaquetsVO vo = new PaquetsVO();	
			BeanUtils.copyProperties(vo, to);
		    vo = paquetsBO.load(vo);
		    BeanUtils.copyProperties(to, vo);
		   		    
		    FormUtils.setFormDisplayMode(request, form, FormUtils.INSPECT_MODE);
			   
		    return mapping.findForward("success");
    }
    
    /**
	 * Elimina un registre.
	 * 
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return
	 * @throws Exception
	 */
    public ActionForward delete(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("delete");
	    	
	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
	    	PaquetsTO to = (PaquetsTO) actionForm.getTarget();
			
	    	PaquetsVO vo = new PaquetsVO();	
			BeanUtils.copyProperties(vo, to);
			logService.getLog(this.getClass()).debug("Eliminando: " + vo.getPaqId());
	    	
			if (vo.getPaqId() != null)
				paquetsBO.delete(vo);

		    return mapping.findForward("deleteSuccess");
    }
    
    /**
     * 
     * @param mapping
     * @param form
     * @param request
     * @param response
     * @return
     * @throws Exception
     */
    public ActionForward paquet(ActionMapping mapping, ActionForm form,
	        javax.servlet.http.HttpServletRequest request,
	        javax.servlet.http.HttpServletResponse response)
	        throws Exception {	    	    	      
			logService.getLog(this.getClass()).debug("paquet");
				
			request.getSession().setAttribute("petId", (String)request.getSession().getAttribute("petIdEdit"));
		
			SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
			PaquetsTO to = (PaquetsTO) actionForm.getTarget();
		
			BeanUtils.copyProperties(form, to);				
			valueListActionHelper.search(mapping,form,request,response);    	                
	       
			return mapping.findForward("success1");
	}
    
    /**
     * Mostra llistat paquets en estat INSTALAT per poder afegir-lo a la nova petici
     * 
     * @param mapping
     * @param form
     * @param request
     * @param response
     * @return
     * @throws Exception
     */
    public ActionForward afegir(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("afegir");
	    	
 	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
			PaquetsTO to = (PaquetsTO) actionForm.getTarget();
		
			BeanUtils.copyProperties(form, to);				
			valueListActionHelper.search(mapping,form,request,response);
	    	
	    	return mapping.findForward("plist");
    }
    
    /**
     * Llista els paquets d'una petici
     * 
     * @param mapping
     * @param form
     * @param request
     * @param response
     * @return
     * @throws Exception
     */
    public ActionForward paquetlist(ActionMapping mapping, ActionForm form,
	        javax.servlet.http.HttpServletRequest request,
	        javax.servlet.http.HttpServletResponse response)
	        throws Exception {		
			logService.getLog(this.getClass()).debug("paquetlist");
			
			request.getSession().setAttribute("petIdNou", (String)request.getParameter("petId"));
			
			SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
			PaquetsTO to = (PaquetsTO) actionForm.getTarget();
		
			BeanUtils.copyProperties(form, to);				
			valueListActionHelper.search(mapping,form,request,response);
			
			return mapping.findForward("plist");
	}
    
        
    /**
    * Versionar paquet ja installat
    * 
    * @param mapping
    * @param form
    * @param request
    * @param response
    * @return
    * @throws Exception
    */
    public ActionForward versionar(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("afegir");
	    	
	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;        
	        PaquetsTO to = (PaquetsTO) actionForm.getTarget();
	        PaquetsVO vo = new PaquetsVO();
	        BeanUtils.copyProperties(vo, to);
		    vo = paquetsBO.load(vo);
		    PaquetsVO nou = new PaquetsVO();
		    BeanUtils.copyProperties(nou, to);
		    nou = paquetsBO.load(vo);
		    BeanUtils.copyProperties(to, nou);
		    to.setPaqVersio(vo.getPaqVersio()+1);
	        
		    FormUtils.setFormDisplayMode(request, form, FormUtils.EDIT_MODE);
		    paquetsBO.save(nou);
		    paquetsBO.addToPeticio(nou.getPaqId(),(String)request.getSession().getAttribute("petIdNou"));
		    
	        return mapping.findForward("success");
    }
    
    /**
     * 
     * @param mapping
     * @param form
     * @param request
     * @param response
     * @return
     * @throws Exception
     */
    public ActionForward afegirPeticio(ActionMapping mapping, ActionForm form,
	        javax.servlet.http.HttpServletRequest request,
	        javax.servlet.http.HttpServletResponse response)
	        throws Exception {	    	    	      
			logService.getLog(this.getClass()).debug("paquet");
				
			paquetsBO.addToPeticio(request.getParameter("paqId"),(String)request.getSession().getAttribute("petIdNou"));
	       
			return mapping.findForward("success1");
	}
    
    public ActionForward searchExportPDF(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response) throws Exception {
    		request.setAttribute("displayProvider","ExportPDF");
    		return this.search(mapping,form,request,response);
    }
    
    public ActionForward searchExportExcel(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response) throws Exception {
    		request.setAttribute("displayProvider","ExportExcel");
    		return this.search(mapping,form,request,response);
    }

    public ActionForward cancel(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("cancel");
	    	
	    	FormUtils.setFormDisplayMode(request, form, FormUtils.CREATE_MODE);
		    return mapping.findForward("list");
    }
    
	/**
	 * @return el valueListActionHelper
	 */
	public ValueListActionHelper getValueListActionHelper() {
		return valueListActionHelper;
	}

	/**
	 * @param valueListActionHelper el valueListActionHelper a establecer
	 */
	public void setValueListActionHelper(ValueListActionHelper valueListActionHelper) {
		this.valueListActionHelper = valueListActionHelper;
	}

	public void setEstatsBO(EstatsBO estatBO) {
		this.estatsBO = estatBO;
	}
    
	public EstatsBO getEstatsBO() {
		return estatsBO;
	}
	
	public void setContextBO(ContextBO contextBO) {
		this.contextsBO = contextBO;
	}
    
	public ContextBO getContextBO() {
		return contextsBO;
	}
	
	public void setGrupBO(GrupsBO grupBO) {
		this.grupsBO = grupBO;
	}
    
	public GrupsBO getGrupBO() {
		return grupsBO;
	}
	
	public void setPaquetsBO(PaquetsBO paquetBO) {
		this.paquetsBO = paquetBO;
	}
    
	public PaquetsBO getPaquetsBO() {
		return paquetsBO;
	}
	
	public SuffixBasedPropertyPlaceholderConfigurer getConfigurationService() {
		return configurationService;
	}

	public void setConfigurationService(SuffixBasedPropertyPlaceholderConfigurer service) {
		configurationService = service;
	}

	
	public I18nService getI18nService() {
		return i18nService;
	}

	public void setI18nService(I18nService service) {
		i18nService = service;
	}
	
}

