package es.bcn.gca.necn.web.struts.action;




import java.util.Date;

import net.opentrends.openframe.core.util.beanutils.BeanUtils;
import net.opentrends.openframe.services.configuration.springframework.beans.factory.config.SuffixBasedPropertyPlaceholderConfigurer;
import net.opentrends.openframe.services.exceptions.BusinessException;
import net.opentrends.openframe.services.i18n.I18nService;
import net.opentrends.openframe.services.persistence.exception.PersistenceServiceException;
import net.opentrends.openframe.services.web.lists.ValueListActionHelper;
import net.opentrends.openframe.services.web.struts.DispatchActionSupport;
import net.opentrends.openframe.services.web.struts.SpringBindingActionForm;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.springframework.dao.DataIntegrityViolationException;

import es.bcn.gca.necn.common.model.PeticionsVO;
import es.bcn.gca.necn.common.model.bo.EstatsBO;
import es.bcn.gca.necn.common.model.bo.PeticionsBO;
import es.bcn.gca.necn.common.model.bo.ProductesBO;
import es.bcn.gca.necn.web.pojo.PeticionsTO;
import fr.improve.struts.taglib.layout.util.FormUtils;

/**
 * Action example for XxxBO
 * 
 * @author MMO
 */

public class PeticionsAc extends DispatchActionSupport  {
	/**
	 * BO en el que deleguem les crides
	 */
    private PeticionsBO peticionsBO;
    private EstatsBO estatsBO;
    private ProductesBO productesBO;
    private ValueListActionHelper valueListActionHelper;
    private SuffixBasedPropertyPlaceholderConfigurer configurationService;
    private I18nService i18nService;
    private Date data_creacio;
    private Date data;

    
	/**
	 * Bsqueda inicial, idntico a search pero antes de iniciar la bsqueda borra todos los parmetros
	 * que encuentre en la session
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return
	 * @throws Exception
	 */
	public ActionForward searchIni(ActionMapping mapping, ActionForm form,
	        javax.servlet.http.HttpServletRequest request,
	        javax.servlet.http.HttpServletResponse response)
	        throws Exception {	    	    	      
		logService.getLog(this.getClass()).debug("searchIni");
	    request.getSession().setAttribute(valueListActionHelper.getTableId(), null);  	  
	    
	    return this.search(mapping,form,request,response);
	}
	
	/**
	 * Bsqueda, realiza una consulta
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return
	 * @throws Exception
	 * @see 
	 */
	public ActionForward search(ActionMapping mapping, ActionForm form,
	        javax.servlet.http.HttpServletRequest request,
	        javax.servlet.http.HttpServletResponse response)
	        throws Exception {		
		logService.getLog(this.getClass()).debug("search");
		
		SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
		PeticionsTO to = (PeticionsTO) actionForm.getTarget();
		
		BeanUtils.copyProperties(form, to);				
		valueListActionHelper.search(mapping,form,request,response);	    	                
	    
		return mapping.findForward("success");
	}
    
    /**
	 * Muestra el formulario de mantenimiento en modo de creacin. 
	 * 
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return
	 * @throws Exception
	 */
    public ActionForward create(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("create");
		   	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
		   	data = new Date();
		   	data_creacio = new Date(data.getTime());
		   		   	
		   	PeticionsTO to = (PeticionsTO) actionForm.getTarget();
		   	to.setPetEstat("ATURAT");
			to.setPetDataCreacio(data_creacio);
			to.setPetDataEstat(data_creacio);
	    	
			FormUtils.setFormDisplayMode(request, form, FormUtils.CREATE_MODE);
	  
			return mapping.findForward("success");
    }

    public ActionForward save(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
    		throws Exception {
    		logService.getLog(this.getClass()).debug("save");
    		ActionMessages errors = new ActionMessages();
    	    
            SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
            PeticionsTO to = (PeticionsTO) actionForm.getTarget();
            PeticionsVO vo = new PeticionsVO();
           
            BeanUtils.copyProperties(vo, to);
            vo = peticionsBO.load(vo);
            BeanUtils.copyProperties(vo, to);
            
            if (vo.getPetId() != null) {
            	try{
            		peticionsBO.saveOrUpdate(vo);
            	}
            		catch (DataIntegrityViolationException e) {
						String error="error.variable";
						String mensage=e.getMostSpecificCause().getLocalizedMessage();
						errors.add("errorGeneral", new ActionMessage(error,mensage));
					}catch (PersistenceServiceException e) {
						String error="error.variable";
						String mensage=e.getLocalizedMessage();
						errors.add("errorGeneral", new ActionMessage(error,mensage));
					}catch (BusinessException e) {
						String error="error.variable";
						String mensage=e.getLocalizedMessage();
						errors.add("errorGeneral", new ActionMessage(error,mensage));
					}catch (Exception e) {
						String error="error.variable";
						String mensage=e.getLocalizedMessage();
						errors.add("errorGeneral", new ActionMessage(error,mensage));
					}
            }

            return mapping.findForward("list");
        }

        public ActionForward saveNew(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
        	logService.getLog(this.getClass()).debug("saveNew");
	    	ActionMessages errors = new ActionMessages();
	    	
            SpringBindingActionForm actionForm = (SpringBindingActionForm) form;        
            PeticionsTO to = (PeticionsTO) actionForm.getTarget();
            PeticionsVO vo = new PeticionsVO();
            to.setProducte(to.getProductes().getProdId());         
           
            BeanUtils.copyProperties(vo, to);
            try{
            	peticionsBO.save(vo);
            }
    		catch (DataIntegrityViolationException e) {
				String error="error.variable";
				String mensage=e.getMostSpecificCause().getLocalizedMessage();
				errors.add("errorGeneral", new ActionMessage(error,mensage));
			}catch (PersistenceServiceException e) {
				String error="error.variable";
				String mensage=e.getLocalizedMessage();
				errors.add("errorGeneral", new ActionMessage(error,mensage));
			}catch (BusinessException e) {
				String error="error.variable";
				String mensage=e.getLocalizedMessage();
				errors.add("errorGeneral", new ActionMessage(error,mensage));
			}catch (Exception e) {
				String error="error.variable";
				String mensage=e.getLocalizedMessage();
				errors.add("errorGeneral", new ActionMessage(error,mensage));
			}
           
            return mapping.findForward("list");
        }
        
    /**
	 * Muestra el formulario con los campos en modo de edicin.
	 * 
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return
	 * @throws Exception
	 */
    public ActionForward edit(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("edit");
	    	request.getSession().setAttribute("petIdEdit",request.getParameter("petId"));
	    	String forward = "success";

	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
			PeticionsTO to = (PeticionsTO) actionForm.getTarget();
			
			PeticionsVO vo = new PeticionsVO();	
			
			BeanUtils.copyProperties(vo, to);
			vo = peticionsBO.load(vo);
		    BeanUtils.copyProperties(to, vo);
            
		    FormUtils.setFormDisplayMode(request, form, FormUtils.EDIT_MODE);
		    
		    if (to.getPetEstat().equals("ATURAT")){
		    	forward = "success";
		    }
		    
		    else if (to.getPetEstat().equals("PAQUETITZANT")) {
		    	forward = "successPaq";
		    }
		    else if (to.getPetEstat().equals("PENDENT MAQUETA")) {
		    	forward = "successLlest";
    		}	
		    else if (to.getPetEstat().equals("LLEST MAQUETA")) {
		    	forward = "successDistri";
    		}
		    else if (to.getPetEstat().equals("DISTRIBUCIO")) {
		    	forward = "successInst";
    		}
		    
		    return mapping.findForward(forward);
    }
    
    /**
	 * Muestra los campos de un registro en modo consulta.
	 * 
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return
	 * @throws Exception
	 */
    public ActionForward inspect(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("inspect");
						
	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
			PeticionsTO to = (PeticionsTO) actionForm.getTarget();
			
			PeticionsVO vo = new PeticionsVO();	
			BeanUtils.copyProperties(vo, to);
		    vo = peticionsBO.load(vo);
		    BeanUtils.copyProperties(to, vo);
		   		    
		    FormUtils.setFormDisplayMode(request, form, FormUtils.INSPECT_MODE);
		    
		    return mapping.findForward("success");
    }
    
    /**
	 * Elimina un registro.
	 * 
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return
	 * @throws Exception
	 */
    public ActionForward delete(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("delete");
	    	
	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
			PeticionsTO to = (PeticionsTO) actionForm.getTarget();
			
			PeticionsVO vo = new PeticionsVO();	
			BeanUtils.copyProperties(vo, to);
			logService.getLog(this.getClass()).debug("Eliminando: " + vo.getPetId());
	    	
			if (vo.getPetId() != null)
				peticionsBO.delete(vo);

		    return mapping.findForward("deleteSuccess");
    }
    
    public ActionForward searchExportPDF(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response) throws Exception {
        request.setAttribute("displayProvider","ExportPDF");
        return this.search(mapping,form,request,response);
    }
    
    public ActionForward searchExportExcel(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response) throws Exception {
        request.setAttribute("displayProvider","ExportExcel");
        return this.search(mapping,form,request,response);
    }

    public ActionForward cancel(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("cancel");
	    	
	    	FormUtils.setFormDisplayMode(request, form, FormUtils.CREATE_MODE);
		    return mapping.findForward("list");
    }
    
    public ActionForward paquetitzant(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("paquetitzant");
	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
	    	data = new Date();
		   	data_creacio = new Date(data.getTime());
		   	
	    	PeticionsTO to = (PeticionsTO) actionForm.getTarget();
	    	PeticionsVO vo = new PeticionsVO();
	    	to.setPetEstat("PAQUETITZANT");  
	       	to.setPetDataEstat(data_creacio);
	     	BeanUtils.copyProperties(vo, to);
	        peticionsBO.saveOrUpdate(vo); 
	                   
	        return mapping.findForward("list");
    }
    
    public ActionForward pendent(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("pendent");
	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
	    	data = new Date();
		   	data_creacio = new Date(data.getTime());
		   	
	    	PeticionsTO to = (PeticionsTO) actionForm.getTarget();
	    	PeticionsVO vo = new PeticionsVO();
	    	to.setPetEstat("PENDENT MAQUETA");  
	    	to.setPetDataEstat(data_creacio);
	    	BeanUtils.copyProperties(vo, to);
            peticionsBO.saveOrUpdate(vo); 
	    	
            return mapping.findForward("list");
    }
    
    public ActionForward llestmaqueta(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("llestmaqueta");
	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
	    	data = new Date();
		   	data_creacio = new Date(data.getTime());
		   	
	    	PeticionsTO to = (PeticionsTO) actionForm.getTarget();
	    	PeticionsVO vo = new PeticionsVO();
	    	to.setPetEstat("LLEST MAQUETA");  
	    	to.setPetDataEstat(data_creacio);
	    	BeanUtils.copyProperties(vo, to);
            peticionsBO.saveOrUpdate(vo); 
                  
	    	return mapping.findForward("list");
    }
    
    public ActionForward distribucio(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("distribucio");
	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
	    	data = new Date();
		   	data_creacio = new Date(data.getTime());
		   	
	    	PeticionsTO to = (PeticionsTO) actionForm.getTarget();
	    	PeticionsVO vo = new PeticionsVO();
	    	to.setPetEstat("DISTRIBUCIO");  
	    	to.setPetDataEstat(data_creacio);
	    	BeanUtils.copyProperties(vo, to);
            peticionsBO.saveOrUpdate(vo); 
	    	
	    	return mapping.findForward("list");
    }
    
    public ActionForward instalada(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("instalada");
	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
	    	data = new Date();
		   	data_creacio = new Date(data.getTime());
		   	
	    	PeticionsTO to = (PeticionsTO) actionForm.getTarget();
	    	PeticionsVO vo = new PeticionsVO();
	    	to.setPetEstat("INSTALADA");  
	    	to.setPetDataEstat(data_creacio);
	    	BeanUtils.copyProperties(vo, to);
            peticionsBO.saveOrUpdate(vo); 
	    	
	    	return mapping.findForward("list");
    }
    
    public ActionForward rebutjat(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("rebutjat");
	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
	    	data = new Date();
		   	data_creacio = new Date(data.getTime());
		   	
	    	PeticionsTO to = (PeticionsTO) actionForm.getTarget();
	    	PeticionsVO vo = new PeticionsVO();
	    	to.setPetEstat("REBUTJAT"); 
	    	to.setPetDataEstat(data_creacio);
	    	BeanUtils.copyProperties(vo, to);
            peticionsBO.saveOrUpdate(vo); 
	    	
	    	return mapping.findForward("list");
    }
    
    public ActionForward paquet(ActionMapping mapping, ActionForm form,
            javax.servlet.http.HttpServletRequest request,
            javax.servlet.http.HttpServletResponse response)
            throws Exception {
	    	logService.getLog(this.getClass()).debug("paquet");
	 	   	    	
	    	SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
			PeticionsTO to = (PeticionsTO) actionForm.getTarget();
			
			BeanUtils.copyProperties(form, to);				
			valueListActionHelper.search(mapping,form,request,response);
	       	
	    	return mapping.findForward("paquet");
    }
    
    
	/**
	 * @return el valueListActionHelper
	 */
	public ValueListActionHelper getValueListActionHelper() {
		return valueListActionHelper;
	}

	/**
	 * @param valueListActionHelper el valueListActionHelper a establecer
	 */
	public void setValueListActionHelper(ValueListActionHelper valueListActionHelper) {
		this.valueListActionHelper = valueListActionHelper;
	}

	public void setEstatsBO(EstatsBO estatBO) {
		this.estatsBO = estatBO;
	}
    
	public EstatsBO getEstatsBO() {
		return estatsBO;
	}
	
	public void setProductesBO(ProductesBO producteBO) {
		this.productesBO = producteBO;
	}
    
	public ProductesBO getProductesBO() {
		return productesBO;
	}
	
	public void setPeticionsBO(PeticionsBO peticioBO) {
		this.peticionsBO = peticioBO;
	}
    
	public PeticionsBO getPeticionsBO() {
		return peticionsBO;
	}
	
	public SuffixBasedPropertyPlaceholderConfigurer getConfigurationService() {
		return configurationService;
	}

	public void setConfigurationService(SuffixBasedPropertyPlaceholderConfigurer service) {
		configurationService = service;
	}

	
	public I18nService getI18nService() {
		return i18nService;
	}

	public void setI18nService(I18nService service) {
		i18nService = service;
	}
	
}

