var OpenFrameFieldTag = {
  Version: '1.0'
}

var OpenFrameTextFieldTag = {
  Version: '1.0'
}



/**
 * Function to obtain the index of a fieldName in a form
 */
function getFormIndex (form, fieldName) {
  var found = false;
  for (var i = 0; i < form.elements.length; i++)
    if ((found = form.elements[i].name == fieldName))
      break;
  return found ? i : -1;
}


/**
 * Extension of Ajax tag Base
 */
 
OpenFrameFieldTag.Base = function() {};
OpenFrameFieldTag.Base.prototype = (new AjaxJspTag.Base()).extend({
});


OpenFrameTextFieldTag.Base = function() {};
OpenFrameTextFieldTag.Base.prototype = (new OpenFrameFieldTag.Base()).extend({
});


/******************************************************************************
 * openFrame Tooltips behaviour
 * Example of use  :
 * <script type="text/javascript">
 *   new OpenFrameTextFieldTag.Tooltip(
 *     {
 *           source: "subject",
 * 			 tooltipMessage: "message",
 *           tooltipTitleMessage: "title",
 * 			 tooltipOptions: "options"
 *     });
 * </script>
 ******************************************************************************/
OpenFrameFieldTag.Tooltip = Class.create();
OpenFrameFieldTag.Tooltip.prototype=(new OpenFrameFieldTag.Base()).extend({
 initialize: function(options) {
    this.setOptions(options);

    //Si buscamos por getElemebtById, como era el caso, tendremos que en modo inspect no tendremos
    //ningun elemento del DOM con ese id. Lo que se ha de hacer es localizar el elemento de tipo Label
    // con atributo for == this.options.source!!!Ya que el tooltip se aade al Label no al input
    //if (this.options.sourceElem) {
    	//var element = this.options.sourceElem;

        // Obtain associated label with 'for' attribute equals to id of this element
		var labels = document.getElementsByTagName("label");			

			
		for (var i = labels.length; --i >= 0;) {
			var l = labels[i];
			
			var forName = this.getForAttributeOfLabel(l);
			if (forName) {
								

				//if (forName==element.id) {					
				if (forName==this.options.source) {					
					this.options.sourceElem = l; //Aqui ya se ve el absurdo que era recuperar la referencia al input, ya que se volvia a referenciar al label
					// Put cursor as help
					l.style.cursor = "help";
					// Put an href containing label
					
					var element = this.options.sourceElem;
				  	var tooltipMessage = this.options.tooltipMessage;
				  	var tooltipTitleMessage = this.options.tooltipTitleMessage;
				 	var tooltipOptions = this.options.tooltipOptions;
					
					var callTooltip = "domTT_activate(this, event";
					if (tooltipTitleMessage && tooltipTitleMessage!="") {
						callTooltip = callTooltip + ",'caption','" + tooltipTitleMessage + "'";
					}
					
					if (tooltipMessage && tooltipMessage!="") {
						callTooltip = callTooltip + ",'content','" + tooltipMessage + "'";
					} 
				
					
				
					if (tooltipOptions && tooltipOptions!="") {
						callTooltip = callTooltip + "," + tooltipOptions;
					} else {
						callTooltip = callTooltip + ",'trail','x'";		
					}
				
					callTooltip = callTooltip + ");";	
					
					var callFunction = "on" + this.options.eventType + "=\"";
					callFunction = callFunction + callTooltip
					callFunction = callFunction + "\"";
					
					l.innerHTML = "<a class='tooltip' href=\"javascript:void(0)\"" + callFunction + ">" + l.innerHTML.toString() + "</a>";														
					//alert(l.innerHTML)
				}
			}
				
		}
   // }    
    	
    
  },

  /* Depending on browser the DOM of attribute 'for' of label has been defined in different attribute? */
  getForAttributeOfLabel:function(label) {
  	var forLabel = label.getAttribute("htmlFor");
	if (!forLabel) {
  		forLabel = label.getAttribute("for");  		    	
  	}
 	return forLabel;
  },


  setOptions: function(options) {
    this.options = {
      //sourceElem: $(options.source),
      eventType: options.eventType ? options.eventType : "mouseover"
    }.extend(options || {});
  }
});



/******************************************************************************
 * openFrame Calendar behaviour
 * An image with icon will be generated
 * Example of use  :
 * <script type="text/javascript">
 *   new OpenFrameTextFieldTag.Calendar(
 *     {
 *           source: "source",
 * 			 datePattern: "dd/MM/yyyy"
 *     });
 * </script>
 ******************************************************************************/
OpenFrameTextFieldTag.Calendar = Class.create();
OpenFrameTextFieldTag.Calendar.prototype=(new OpenFrameTextFieldTag.Base()).extend({
 initialize: function(options) {
    this.setOptions(options);
    if (this.options.sourceElem) {
    
    	// First generate <img> tag with image
    	var sourceElemId = this.options.sourceElem.id;
    	var calendarId = sourceElemId + "-calendar";
    	var content = "<img src=\""+contextPath+"/fwk/img/calendars/bcn/calendar.gif\" id=\"" +  calendarId + "\"";
    	content = content + " class=\"openFrame_calendar_icon\"";
    	content = content + "/>";
    	new Insertion.After(this.options.sourceElem,content);
    	
    	var dynarchDateFormat = this.getDynarchDateFormat(this.options.datePattern);
    	
    	var calendarCall = "Calendar.setup({";
    	calendarCall+= "inputField:\"" + this.options.sourceElem.id + "\",";
    	calendarCall+= "ifFormat:\"" + dynarchDateFormat + "\",";
    	//timeformat ens indica si el format cont una hora de 24, de 12 o no cont hora
    	var timeFormat = this.timeFormat(this.options.datePattern);
    	if (timeFormat != null) {
    		calendarCall+= "showsTime:\"true\",";
    		calendarCall+= "timeFormat:\""+timeFormat+"\",";
    	}
    	calendarCall+= "button:\"" + calendarId + "\"";
    	calendarCall+= "});";
    	eval(calendarCall);    	
    }
  },


  /*
    passem d'una data en el format java com l'especificat aqu 
    http://java.sun.com/j2se/1.4.2/docs/api/java/text/SimpleDateFormat.html
    al format especificat aqu
    http://en.wikipedia.org/wiki/Date_(Unix)#Formatting
    Noms tenim en compte
  y  	Year
  M 	Month in year
  d  	Day in month
  H  	Hour in day (0-23)
  h  	Hour in am/pm (1-12)
  m  	Minute in hour
  s  	Second in minute
  a		Am/pm marker 

  2 'd' passen a %d
  2 'M' passen a %m
  2 'y' passsen a %y
  4 'y' passsen a %Y
  2 'h' passen a %I
  2 'H' passen a %H
  2 'm' passen a %M
  2 's' passen a %S
  1 'a' passem a %p
  */ 
      getDynarchDateFormat: function(datePattern) {
  	  //conjunt de lletres que representen una hora en un SimpleDateFormat
  	  var CONJUNT_CARACTERS_ESPECIALS = "adMyhHms";
  	  var caracterEspecial = null;
  	  var comptador = 0;
  	  var formatUnix = "";
  	  var texteEscapat = false;
  	  for (var i = 0; i < datePattern.length; i++) {
  		  var caracter = datePattern.charAt(i);
  		  //si s'estaven acumulant caracters especials i hi ha un canvi, cal tractar el grup
  		  //que s'estava acumulant
  		  if (caracterEspecial != null && (caracterEspecial != caracter)) {
			  formatUnix += this.tractaCaracterEspecial(caracterEspecial, comptador);
  			  caracterEspecial = null;
  			  comptador = 0;
  		  }
  		  //tractem la cometa simple
  		  if (caracter == '\'') {
  			  //si s el primer caracter d'una part escapada s'ha de pintar, es a dir '' -> \'
  			  if (texteEscapat && i > 0 && datePattern.charAt(i-1) == '\'') {
	  			  formatUnix += '\'';
  			  }
  			  //sempre la cometa simple indica l'inici o el fi d'una part escapada
  			  texteEscapat = !texteEscapat;
  		  } else {
  			  //si es tracta d'un texte escapat l'incloiem dins el patr
	  		  if (texteEscapat) {
	  			  formatUnix += caracter;
	  		  } else {
	  			if (CONJUNT_CARACTERS_ESPECIALS.indexOf(caracter) != -1) {
	  				//ara, a caracterEspecial noms hi pot haver, o be null (i comptador a 0) o un caracter igual a 'caracter'
	  				caracterEspecial = caracter;
	  				comptador ++;
	  			} else if (caracter < 'A' || caracter > 'z') {
	  				//els caracters [A-Z] [a-z] estn reservats, per incloure'ls al patr cal escapar-los
	  				formatUnix += caracter;
	  			}
	  		  }
  		  }
  	  }
  	  //al final de tot mirem si quedava un grup de caracters per tractar
  	  if (caracterEspecial != null) {
  		  formatUnix += this.tractaCaracterEspecial(caracterEspecial, comptador);
  	  }
  	  return formatUnix;
    }, 

    tractaCaracterEspecial: function(caracterEspecial, comptador) {
    	if (caracterEspecial == 'a') {
			  return "%p";
		  }
    	if (caracterEspecial == 'd' && comptador >= 2) {
			  return "%d";
		  }
		  if (caracterEspecial == 'M' && comptador >= 2) {
			  return "%m";
		  }
		  if (caracterEspecial == 'y' && comptador >= 2 && comptador < 4) {
			  return "%y";
		  }
		  if (caracterEspecial == 'y' && comptador >= 4) {
			  return "%Y";
		  }
		  if (caracterEspecial == 'h' && comptador >= 2) {
			  return "%I";
		  }
		  if (caracterEspecial == 'H' && comptador >= 2) {
			  return "%H";
		  }
		  if (caracterEspecial == 'm' && comptador >= 2) {
			  return "%M";
		  }
		  if (caracterEspecial == 's' && comptador >= 2) {
			  return "%S";
		  }
    },
    timeFormat: function(datePattern) {
  	  var texteEscapat = false;
  	  for (var i = 0; datePattern.length > i; i++) {
  		  var caracter = datePattern.charAt(i);
  		  if (caracter == '\'') {
  			  texteEscapat = !texteEscapat;
  		  }
  		  
  		  if (!texteEscapat) {
  			//si el caracter no est escapat comprovem que no sigui un dels que representa una hora
  			  if (caracter == 'H') {
  				  return "24";
  			  } else if (caracter == 'h') {
  				  return "12";
  			  }
  		  }
  	  }
  	  return null;
    }, 
  setOptions: function(options) {
    this.options = {
      sourceElem: $(options.source),
      datePattern: options.datePattern ? options.dattePattern : "dd/MM/yyyy"      
    }.extend(options || {});
  }
});






