
var OpenFrameSelectFieldTag = {
  Version: '1.0'
}

function populateSelect(dataFromServer,dataFromBrowser) {

    // Obtain target from dataFromBrowser of previous call to callback
    var targetElem = $(dataFromBrowser['target']);
    var defaultSelected = dataFromBrowser['defaultSelected'];
    var otherKey = dataFromBrowser['otherKey'];
    var otherValue = dataFromBrowser['otherValue'];  
    	
	                   	
    if (targetElem) {	
    			
		var selectMultiple = (targetElem.type == "select-multiple");
		var aDefaultSelected;
		if(selectMultiple)		
			aDefaultSelected = defaultSelected.split(',');
		
		if (targetElem.options) {
    	    // reset target field    
	    	targetElem.options.length = 0;
	    }
	    targetElem.disabled = false;    
	    
	    var startIndex = 0;
	    if (otherKey != null) {
	  		targetElem.options[startIndex] = new Option(otherKey, otherValue);
	  		startIndex++;
	  	}
	    if (dataFromServer) {
    		// grab list of options from list
    		var items = dataFromServer;
    		var itemsQuoted = new Array(items.length);
    		// Add a "'" to each value for presenting
		    for (var i=0; i<items.length; i++) {    		      
		      itemsQuoted[i] = new Object();
		      itemsQuoted[i]['label'] = "'" + items[i]['label'] + "'";
		      itemsQuoted[i]['value'] = "'" + items[i]['value'] + "'";
		      var label = items[i]['label'];
		      var value = items[i]['value'];
	  	      targetElem.options[i+startIndex] = new Option(label, value);
	  	      if(!selectMultiple && value == defaultSelected){
	  	      	targetElem.options[i+startIndex].selected = true;
	  	      }else if(selectMultiple && aDefaultSelected.length >0){
				 for (j = 0; j < aDefaultSelected.length; j++) {
				   if (value == aDefaultSelected[j]) {
					 targetElem.options[i+startIndex].selected = true;
				   }
				 }
			  }
    		}    		    		
	    	//DWRUtil.addOptions(targetElemId,dataFromServer,'label','value');
	    }
	    
	    //fire onChange event	    
	    if( document.createEvent ) {
	        var evObj = document.createEvent('MouseEvents');
	        evObj.initEvent('change', true, true);
	        targetElem.dispatchEvent(evObj);
	    } else if( document.createEventObject ) {
	        // iExplorer
	    	targetElem.fireEvent('onchange');
	    }	    
    }    
}


/**
 * Extension of OpenFrameFieldTag
 */ 
OpenFrameSelectFieldTag.Base = function() {};
OpenFrameSelectFieldTag.Base.prototype = (new AjaxJspTag.Base()).extend({
});


/******************************************************************************
 * openFrame Select Dependency behaviour
 * Example of use  :
 * <script type="text/javascript">
 *   new OpenFrameSelectFieldTag.SelectTarget(
 *     {
 *           defaultSelected: "...", // defaultSelected
 *           source: "...", // id of source select
 * 			 target: "...", // id of target select
 *           paramName: "title" // name of parameter to be created in order to populate target
 *			 optionsSourceListName: "" // name of configured list name of target options
 *     });
 * </script>
 ******************************************************************************/
 

OpenFrameSelectFieldTag.SelectTarget = Class.create();
OpenFrameSelectFieldTag.SelectTarget.prototype=(new OpenFrameSelectFieldTag.Base()).extend({

  initialize: function(options) {
    this.setOptions(options);
        
    if (this.options.sourceElem) {    	
    	this.attachBehaviors(this.options.sourceElem, this.options.eventType, this.actionElemChanged, this);
    	this.actionElemChanged(new Object());
	}
  },


  setOptions: function(options) {   
        
    this.options = {
	  defaultSelected: $(options.defaultSelected),	 
	  // MMO: 29/08/2011 Modificaci per a permetre la dependncia mltiple, i.e. dependre de ms d'un element del DOM
	  sourceElem: this.getSourceElements(options.source),
	  // MMO: 29/08/2011 Fi modificaci  
	  targetElem: $(options.target),
	  paramName: options.paramName,
	  optionsTargetListName: $(options.targetListName),
	  eventType: options.eventType ? options.eventType : "change"
    }.extend(options || {});
  },  
  
  getSourceElements: function(sourceElemDef) {
    var sourceElements = new Array();
	var aSourceElemDef = sourceElemDef.split("#");

	for (var i = 0; i < aSourceElemDef.length; i++) {			
		sourceElements.push($(aSourceElemDef[i]));
	}

	return sourceElements;
  },

  
  actionElemChanged: function(e) {
  	 	  
	  if (this.options.targetElem.tagName.toLowerCase() == 'select') {
		 // MMO: 29/08/2011 Modificaci per a permetre la dependncia mltiple, i.e. dependre de ms d'un element del DOM
		 var sourceElems = this.options.sourceElem;     		 
		 var paramNames = this.options.paramName.split("#");
	     
	     // Create parameters to call 'getOptions'
		 var parametersCall = new Object();
		 if (isArray(sourceElems)) {
			for (var i=0; i<sourceElems.length; i++) {				
				parametersCall[paramNames[i]] = $F(sourceElems[i]);   								
			}	
		 }else{			
			parametersCall[paramNames[0]] = $F(sourceElems);   
		 }		 
		// MMO: 29/08/2011 Fi modificaci
		 
		 Event.stop(e);
	  	 
	  	 
		 var optionsListName = this.options.optionsTargetListName;
		 var dataFromBrowser = new Object();
	  	 dataFromBrowser['target'] = this.options.targetElem.id;
	  	 dataFromBrowser['defaultSelected'] = this.options.defaultSelected;
	  	 dataFromBrowser['otherKey'] = this.options.otherKey;
	  	 dataFromBrowser['otherValue'] = this.options.otherValue;
	
		 webOptionsListService.getOptionsFromMap(optionsListName,parametersCall,
		 	{
		 		callback:function(dataFromServer) {
		 			populateSelect(dataFromServer,dataFromBrowser);
		 		},
		 		timeout:5000
		 	}
		 );
       }
  	} 
}); 
  	  
  	   
  	   

