var DivNoticeManager = {
	processing: false,
	processingSubmit: false,
	processingValidation: false,
	message: new Object(),
	targetForm: null,
	
	init: function () { 
		var colAllElements = document.getElementsByTagName("*"); 
		if (colAllElements.length == 0) { 
			colAllElements = document.all; 
		} 
		
		for (var i=0; i < colAllElements.length; i++) { 
			if (colAllElements[i].id.length > 0) { 
				this[colAllElements[i].id] = colAllElements[i]; 
			}
		} 
	},
		
	//Desactiva els button del formulari
	disableElements: function() {
		if(!this.targetForm)
			return;
		
		for (var i=0 ; i < this.targetForm.elements.length; i++) {
			var field = this.targetForm.elements[i];
			if (field.type == 'submit' ||  field.type == 'button') {
				field.disabled = true;
			}
		} 
	},
	
	//Activa els buttons del formulari
	enableElements: function() {
		if(!this.targetForm)
			return;
		
		for (var i=0 ; i < this.targetForm.elements.length; i++) {
			var field = this.targetForm.elements[i];
			if (field.type == 'submit' ||  field.type == 'button') {
				field.disabled = false;
			}
		} 
		
		this.targetForm == null;
	},
	
	setProcessing: function (bProcessing, processType) { 		
		if(processType){
			if(processType == 'submit'){
				processingSubmit = bProcessing;
			} else 	if(processType == 'validation'){
				 processingValidation = bProcessing;
			}		
		}else{		
			this.processing = bProcessing; 
			if(!bProcessing){
				processingSubmit = false;
				processingValidation = false;
			}
		}
	},
	
	
	isProcessing: function (processType) { 
		if(!processType)
			return this.processing; 		
		
		if(processType == 'submit'){
			return processingSubmit;
		}
		
		if(processType == 'validation'){
			return processingValidation;
		}
			
	},
	
	showNotice: function (sType, sMessage) { 
		var divNotice = $('divNotice');		
		if(divNotice){
			divNotice.className = sType+'Notice';						
			divNotice.innerHTML = sMessage;			
			divNotice.style.visibility = "visible"; 
			this.processing = true;			
		}
	},	

	showError: function (sType, sMessage) { 
		var divNotice = $('divNotice');
		if(divNotice){
			divNotice.className = sType+'Notice';								
			divNotice.innerHTML = sMessage;
			divNotice.style.visibility = "visible"; 
			this.processing = true;			
		}
	},		
		
	hideNotice: function(){
		var divNotice = $('divNotice');
		if(divNotice){
			divNotice.style.visibility = "hidden";
			this.processing = false;
		}
	},
	
	updateNotice: function (sMessage){
		var divNotice = $('divNotice');
		if(divNotice){						
			divNotice.innerHTML = sMessage;
		}
	},		

	unnotify: function(){
		DivNoticeManager.hideNotice();	
		DivNoticeManager.enableElements();	
	}	
}