-- CLAUS PRIMRIES

ALTER TABLE PETICIONS ADD CONSTRAINT PK_PETICIONS PRIMARY KEY (PET_ID) USING INDEX TABLESPACE I_GCANEC;
ALTER TABLE PRODUCTES ADD CONSTRAINT PK_PRODUCTES PRIMARY KEY (PROD_ID) USING INDEX TABLESPACE I_GCANEC;
ALTER TABLE PAQUETS ADD CONSTRAINT PK_PAQUETS PRIMARY KEY (PAQ_ID) USING INDEX TABLESPACE I_GCANEC;
ALTER TABLE ESTATS ADD CONSTRAINT PK_ESTATS PRIMARY KEY (ESTAT_ID) USING INDEX TABLESPACE I_GCANEC;
ALTER TABLE PETICIONS_PAQUETS ADD CONSTRAINT PK_GCAINPET_PAQ_00 PRIMARY KEY (PET_ID,PAQ_ID) USING INDEX TABLESPACE I_GCANEC;
ALTER TABLE GRUPS ADD CONSTRAINT PK_GRUPS PRIMARY KEY (GRUP_ID) USING INDEX TABLESPACE I_GCANEC;

-- CLAUS FORNIES

-- 
-- TABLE: PETICIONS 
--

ALTER TABLE PETICIONS ADD CONSTRAINT FK_PETICIONS_01 
    FOREIGN KEY (PROD_ID)
    REFERENCES PRODUCTES(PROD_ID)
;

-- 
-- TABLE: PETICIONS_PAQUETS 
--

ALTER TABLE PETICIONS_PAQUETS ADD CONSTRAINT FK_PETICIONS_PAQUETS_01 
    FOREIGN KEY (PET_ID)
    REFERENCES PETICIONS(PET_ID)
;

ALTER TABLE PETICIONS_PAQUETS ADD CONSTRAINT FK_PETICIONS_PAQUETS_02
    FOREIGN KEY (PAQ_ID)
    REFERENCES PAQUETS(PAQ_ID)
;


--UNIQUE KEYS

ALTER TABLE PETICIONS
ADD CONSTRAINT UQ_PETICIONS_01
UNIQUE (PET_ID, PROD_ID)
USING INDEX TABLESPACE I_GCANEC
;

ALTER TABLE PAQUETS
ADD CONSTRAINT UQ_PAQUETS_01
UNIQUE (PAQ_ID, PAQ_VERSIO)
USING INDEX TABLESPACE I_GCANEC
;

-- CHECK CONSTRAINTS

ALTER TABLE PETICIONS ADD CONSTRAINT CHECK_PETICIONS_PET_URGENT CHECK (IS_LOWER18 IN ('T', 'F'));


--- NOT NULL

ALTER TABLE PETICIONS MODIFY (PET_ID            	CONSTRAINT NN_PET_ID_PETICIONS NOT NULL);
ALTER TABLE PETICIONS MODIFY (PROD_ID           	CONSTRAINT NN_PROD_ID_PETICIONS NOT NULL);
ALTER TABLE PETICIONS MODIFY (PET_CREADOR       	CONSTRAINT NN_PET_CREADOR_PETICIONS NOT NULL);
ALTER TABLE PETICIONS MODIFY (PET_PETICIONARI   	CONSTRAINT NN_PET_PETICIONARI_PETICIONS NOT NULL);
ALTER TABLE PETICIONS MODIFY (PET_DATA_CREACIO  	CONSTRAINT NN_PET_DAL_PETICIONS NOT NULL);
ALTER TABLE PETICIONS MODIFY (PET_ESTAT         	CONSTRAINT NN_PET_ESTAT_PETICIONS NOT NULL);
ALTER TABLE PETICIONS MODIFY (PET_DATA_ESTAT    	CONSTRAINT NN_PET_DATA_ESTAT_PETICIONS NOT NULL);
ALTER TABLE PETICIONS MODIFY (PET_TIQUET        	CONSTRAINT NN_PET_TIQUET_PETICIONS NOT NULL);
ALTER TABLE PETICIONS MODIFY (IS_LOWER18 			CONSTRAINT NN_IS_LOWER18_PETICIONS NOT NULL);

ALTER TABLE PRODUCTES MODIFY (PROD_ID          		CONSTRAINT NN_PROD_ID_PRODUCTES NOT NULL);
ALTER TABLE PRODUCTES MODIFY (PROD_DESC        		CONSTRAINT NN_PROD_DESC_PRODUCTES NOT NULL);
ALTER TABLE PRODUCTES MODIFY (PROD_ESTAT       		CONSTRAINT NN_PROD_ESTAT_PRODUCTES NOT NULL);
ALTER TABLE PRODUCTES MODIFY (PROD_DATA_CREACIO  	CONSTRAINT NN_PROD_DATA_CREACIO NOT NULL);

ALTER TABLE PAQUETS MODIFY (PAQ_ID          	CONSTRAINT NN_PAQ_ID_PAQUETS NOT NULL);
ALTER TABLE PAQUETS MODIFY (PAQ_VERSIO 	 		CONSTRAINT NN_PAQ_VERSIO_PAQUETS NOT NULL);
ALTER TABLE PAQUETS MODIFY (PAQ_DESC        	CONSTRAINT NN_PAQ_DESC_PAQUETS NOT NULL);
ALTER TABLE PAQUETS MODIFY (PAQ_ESTAT 		 	CONSTRAINT NN_PAQ_ESTAT_PAQUETS NOT NULL);
ALTER TABLE PAQUETS MODIFY (PAQ_CONTEXT     	CONSTRAINT NN_PAQ_CONTEXT_PAQUETS NOT NULL);
ALTER TABLE PAQUETS MODIFY (PAQ_DATA_CREACIO 	CONSTRAINT NN_PAQ_DAL_PAQUETS NOT NULL);
ALTER TABLE PAQUETS MODIFY (PAQ_DATA_MODIF	 	CONSTRAINT NN_PAQ_DDM_PAQUETS NOT NULL);

ALTER TABLE GRUPS MODIFY (GRUP_ID    CONSTRAINT NN_GRUP_ID_GRUPS NOT NULL);
ALTER TABLE GRUPS MODIFY (GRUP_NOM   CONSTRAINT NN_GRUP_NOM_GRUPS NOT NULL);

ALTER TABLE PETICIONS_PAQUETS MODIFY (PET_ID    	CONSTRAINT NN_PET_ID_PETICIONS_PAQUETS NOT NULL);
ALTER TABLE PETICIONS_PAQUETS MODIFY (PAQ_ID    	CONSTRAINT NN_PAQ_ID_PETICIONS_PAQUETS NOT NULL);

ALTER TABLE ESTATS MODIFY (ESTAT_ID     CONSTRAINT NN_ESTAT_ID_ESTATS NOT NULL);
ALTER TABLE ESTATS MODIFY (NOM CONSTRAINT NN_NOM_ESTATS NOT NULL);