-- 
-- TABLE: PETICIONS 
--

CREATE TABLE PETICIONS(
    PET_ID             VARCHAR2(8)      ,
    PROD_ID			   VARCHAR2(50)		,
    PET_CREADOR        VARCHAR2(20)      ,
    PET_PETICIONARI    VARCHAR2(20)      ,
    PET_DATA_CREACIO   DATE              ,
    PET_ESTAT          VARCHAR2(2)         ,
    PET_DATA_ESTAT     DATE              ,
    PET_TIQUET         VARCHAR2(8)      ,
    IS_LOWER18         VARCHAR2(1)       ,
    PET_OBSERVACIONS   VARCHAR2(1000)
) 
;


COMMENT ON TABLE PETICIONS IS 'Petici d''instalaci d''un producte (aplicaci)'
;
COMMENT ON COLUMN PETICIONS.PET_ID IS 'Identificador de la petici'
;
COMMENT ON COLUMN PETICIONS.PROD_ID IS 'Identificador del producte'
;
COMMENT ON COLUMN PETICIONS.PET_CREADOR IS 'Usuari que crea la petici'
;
COMMENT ON COLUMN PETICIONS.PET_PETICIONARI IS 'Responsable de client que transmet la petici'
;
COMMENT ON COLUMN PETICIONS.PET_DATA_CREACIO IS 'Data de creaci de petici'
;
COMMENT ON COLUMN PETICIONS.PET_DATA_MODIF IS 'Data de darrera modificaci'
;
COMMENT ON COLUMN PETICIONS.PET_ESTAT IS 'Estat de la petici'
;
COMMENT ON COLUMN PETICIONS.PET_DATA_ESTAT IS 'Data de quan va arrivar a l''estat'
;
COMMENT ON COLUMN PETICIONS.PET_TIQUET IS 'Nmero de l''avs de tiquet de la petici'
;
COMMENT ON COLUMN PETICIONS.IS_LOWER18 IS 'Indicador de petici urgent, S/N'
;
COMMENT ON COLUMN PETICIONS.PET_OBSERVACIONS IS 'Observacions'
;

-- 
-- TABLE: PRODUCTES 
--

CREATE TABLE PRODUCTES(
    PROD_ID            	 VARCHAR2(50)      ,
    PROD_DESC            VARCHAR2(500)     ,
	PROD_DATA_CREACIO    DATE 				,
	PROD_MOTIU_REBUIG    VARCHAR2(1000)    ,
    PROD_DATA_BAIXA      DATE              ,
    PROD_OBSERVACIONS    VARCHAR2(500)		
) 
;


COMMENT ON TABLE PRODUCTES IS 'Catleg d''aplicacions'
;
COMMENT ON COLUMN PRODUCTES.PROD_ID IS 'Identificador del producte (aplicaci)'
;
COMMENT ON COLUMN PRODUCTES.PROD_DESC IS 'Descripci'
;
COMMENT ON COLUMN PRODUCTES.PROD_ESTAT IS 'Estat del producte'
;
COMMENT ON COLUMN PRODUCTES.PROD_DATA_CREACIO IS 'Data de creaci de producte'
;
COMMENT ON COLUMN PRODUCTES.PROD_MOTIU_REBUIG IS 'Motiu rebuig'
;
COMMENT ON COLUMN PRODUCTES.PROD_DATA_BAIXA IS 'Data de baixa (descatalogaci)'
;
COMMENT ON COLUMN PRODUCTES.PROD_OBSERVACIONS IS 'Observacions'
;

-- 
-- TABLE: PAQUETS 
--

CREATE TABLE PAQUETS(
    PAQ_ID	           VARCHAR2(50)     ,
    PAQ_VERSIO         VARCHAR2(4)     ,
    PAQ_DESC           VARCHAR2(50)    ,
    PAQ_ESTAT          VARCHAR2(30)        ,
    PAQ_CONTEXT        VARCHAR2(50)     ,
    PAQ_DATA_CREACIO   DATE            ,
    PAQ_DATA_MODIF	   DATE				,
	PAQ_OBSERVACIONS   VARCHAR2(500)	
) 
;


COMMENT ON TABLE PAQUETS IS 'Paquets que constitueixen una aplicaci'
;
COMMENT ON COLUMN PAQUETS.PAQ_ID IS 'Identificador del paquet NAL'
;
COMMENT ON COLUMN PAQUETS.PAQ_VERSIO IS 'Versi del paquet'
;
COMMENT ON COLUMN PAQUETS.PAQ_DESC IS 'Descripci del paquet'
;
COMMENT ON COLUMN PAQUETS.PAQ_ESTAT IS 'Estat del paquet'
;
COMMENT ON COLUMN PAQUETS.PAQ_CONTEXT IS 'Context d''aplicacions Novell'
;
COMMENT ON COLUMN PAQUETS.PAQ_DATA_CREACIO IS 'Data d''alta'
;
COMMENT ON COLUMN PAQUETS.PAQ_DATA_MODIF IS 'Data darrera modificaci'
;

-- 
-- TABLE: PETICIONS_PAQUETS
--

CREATE TABLE PETICIONS_PAQUETS(
   PET_ID             VARCHAR2(8)     ,
   PAQ_ID             VARCHAR2(50)     
) 
;

COMMENT ON COLUMN PETICIONS_PAQUETS.PET_ID IS 'Identificador de la petici'
;  
COMMENT ON COLUMN PETICIONS_PAQUETS.PAQ_ID IS 'Identificador del paquet'
;


-- 
-- TABLE: GRUPS 
--

CREATE TABLE GRUPS(
    GRUP_ID     VARCHAR2(8)    ,
    GRUP_NOM    VARCHAR2(80)    
) 
;


COMMENT ON TABLE GRUPS IS 'Grups'
;
COMMENT ON COLUMN GRUPS.GRUP_ID IS 'Identificador del grup'
;
COMMENT ON COLUMN GRUPS.GRUP_NOM IS 'Nom del grup'
;


-- 
-- TABLE: ESTATS 
--

CREATE TABLE ESTATS(
    ESTAT_ID			VARCHAR2(2)    ,	
    NOM        			VARCHAR2(15)      
    
) 
;


COMMENT ON TABLE ESTATS IS 'Estats d''una petici, producte o paquet'
;
COMMENT ON COLUMN ESTATS.ESTAT_ID IS 'Identificador de l''estat'
;
COMMENT ON COLUMN ESTATS.NOM IS 'Nom de l''estat'
;

-- 
-- TABLE: CONTEXT 
--

CREATE TABLE CONTEXT(
	CONTEXT_ID			VARCHAR2(2)    ,
	NOM        			VARCHAR2(30)      
    
) 
;


COMMENT ON TABLE CONTEXT IS 'Context o en distribueix un paquet'
;
COMMENT ON COLUMN CONTEXT.NOM IS 'Nom del context'
;


-- SEQNCIES
CREATE SEQUENCE SEQ_GRUP START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 99999999 NOCACHE  NOCYCLE ;
CREATE SEQUENCE SEQ_PET START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 99999999 NOCACHE  NOCYCLE ;
CREATE SEQUENCE SEQ_EST START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 99999999 NOCACHE  NOCYCLE ;
CREATE SEQUENCE SEQ_CON START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 99999999 NOCACHE  NOCYCLE ;